// kinem.cpp - Marcin Abram
// Juelich, Germany, 13.08.2009 r.
// Program na zaliczenie projektu studenckiego nr 6
// patrz: http://koza.if.uj.edu.pl/~abram/juelich/projekty.html
#include<cstdio>
#include<iostream>
#include<fstream>
#include<cmath>
#include"kinem.h"
#include"kolory.h"
using namespace std;

int main(int argc, char *argv[])
{
	// KONTROLA POPRAWNOSCI
	if(argc != 1 && argc != 3)
	{
		printf("Wlacz program bez argumentow i wprowadz dane zgodne z pytaniami,\n");
		printf("jakie wyswiela sie na konsoli, albo z parametrem [-f] i sciezka\n");
		printf("do pliku z parametrami pracy programu. Wiecej jak skonstuowac taki\n");
		printf("plik w README.");
		exit(EXIT_SUCCESS);
	}

	// WCZYTYWANIE DANYCH
	unsigned N, Niter, Nhisto, histogram;
	double a[5], b[5], *m, alpha; 
	if(argc == 1)
	{
		printf("Podaj energie czasteczki A: "); scanf("%lf", &a[0]);
		printf("Podaj mase czasteczki A: "); scanf("%lf", &a[1]);
		printf("Podaj wspolrzedne wersorow pedu czasteczki A (nie musza byc\n");
		printf("znormalizowane). Dla czastki spoczywajacej podaj 0 0 0:\n");
		scanf("%lf %lf %lf", &a[2], &a[3], &a[4]);

		printf("Podaj energie czasteczki B: "); scanf("%lf", &b[0]);
		printf("Podaj mase czasteczki B: "); scanf("%lf", &b[1]);
		printf("Podaj wspolrzedne wersorow pedu czasteczki B (nie musza byc\n");
		printf("znormalizowane). Dla czastki spoczywajacej podaj 0 0 0:\n");
		scanf("%lf %lf %lf", &b[2], &b[3], &b[4]);

		printf("Podaj liczba produktow zderzenia czastek A i B:"); scanf("%u", &N);
		printf("Podaj kolejne masy produktow zderzenia czastek A i B: ");	
		m = new double[N];
		for(unsigned i=0; i<N; i++) { scanf("%lf", &m[i]); }

		printf("Podaj czesc calkowitej liczby czastek, jaka chcialbys zmierzyc: ");
		scanf("%lf", &alpha);
		printf("Podaj liczbe iteracji, do metody Monte Carlo: "); scanf("%d", &Niter);
		printf("Czy zapisac dane do histogramu? (0 na nie, 1 na tak): "); scanf("%d", &histogram);
		printf("Ile iteracji wykanac na potrzeby histogramu? "); scanf("%d", &Nhisto);
	}
	else if(argc == 3)
	{
		if(argv[1][0] == '-' && argv[1][1] == 'f')
		{
			ifstream is;
			is.open(argv[2]);
			for(unsigned i=0; i<5; i++) { is >> a[i]; }
			for(unsigned i=0; i<5; i++) { is >> b[i]; }
			is >> N;
			m = new double[N];
			for(unsigned i=0; i<N; i++) { is >> m[i]; }
			is >> alpha; is >> Niter; is >> histogram; is >> Nhisto;
			is.close();
		}
		else
		{ cerr << "Nieznana flaga." << endl; }
	}

	// TWORZENIE CZTEROPEDOW I MACIERZY PCHNIECIA LORENCOWSKIEGO
	Ped pa(a[0], a[1], a[2], a[3], a[4]);
	Ped pb(b[0], b[1], b[2], b[3], a[5]);

	// Garsc informacji o stworzonych wektorach
	wyczysc_ekran();
	printf("---------------------------------------------------------\n");
	tekst_kolor(TEKST_ZIELONY); tekst_pogrubiony();
	printf("        UKLAD LAB\n");
	tekst_domyslny();
	tekst_podkreslony();
	printf("Charakterystyka czastki:  |    A (GeV)    |    B (GeV)   \n");
	tekst_domyslny();
	printf("   Masa spoczynkowa:      | %13.6e | %13.6e\n", pa.m(), pb.m());
	printf("   Energia calkowita:     | %13.6e | %13.6e\n", pa.E(), pb.E());
	printf("   Ped calkowity:         | %13.6e | %13.6e\n", sqrt(pa.pp()), sqrt(pb.pp()));
	printf("   Ped wzdluz osi OX:     | %13.6e | %13.6e\n", pa.px(), pb.px());
	printf("   Ped wzdluz osi OY:     | %13.6e | %13.6e\n", pa.py(), pb.py());
	printf("   Ped wzdluz osi OZ:     | %13.6e | %13.6e\n", pa.pz(), pb.pz());
	printf("\n");	

	// Przechodze do ukladu CM
	Pchniecie L(pa, pb);
	Ped Lpa = L*pa;
	Ped Lpb = L*pb;

	// Garsc informacji o transformowanych wektorach
	printf("---------------------------------------------------------\n");
	tekst_kolor(TEKST_ZIELONY); tekst_pogrubiony();
	printf("        UKLAD CM\n");
	tekst_domyslny();
	printf("Macierz Lorentza pchniecia ma postac:\n");
	L.wypisz();
	printf("\ngamma = %f, 1-beta = %e\n", L.gamma(), 1-L.beta());
	tekst_podkreslony();
	printf("\nCharakterystyka czastki:  |    A (GeV)    |    B (GeV)   \n");
	tekst_domyslny();
	printf("   Masa spoczynkowa:      | %13.6e | %13.6e\n", Lpa.m(), Lpb.m());
	printf("   Energia calkowita:     | %13.6e | %13.6e\n", Lpa.E(), Lpb.E());
	printf("   Ped calkowity:         | %13.6e | %13.6e\n", sqrt(Lpa.pp()), sqrt(Lpb.pp()));
	printf("   Ped wzdluz osi OX:     | %13.6e | %13.6e\n", Lpa.px(), Lpb.px());
	printf("   Ped wzdluz osi OY:     | %13.6e | %13.6e\n", Lpa.py(), Lpb.py());
	printf("   Ped wzdluz osi OZ:     | %13.6e | %13.6e\n", Lpa.pz(), Lpb.pz());
	printf("\n");	

	// licze maksimalny kat
	printf("---------------------------------------------------------\n");
	if(N == 0)
	{
		printf("Nie moze zajsc proces A + B -> 0");
		exit(EXIT_SUCCESS);
	}
	else if(N == 1)
	{
		printf("Proces A + B -> C moze zajsc tylko dla scisle okreslonej masy m_c\n");
		Ped pc = (Lpa + Lpb)*L;
		if(m[0] != pc.m())
		{
			printf("W tym przypadku tak nie jest.\n");
			printf("Podsumowujac: reakcja jest kinematycznie niedozwolona.\n");
			exit(EXIT_SUCCESS);
		}
		else
		{
			printf("W tym przypadku sytuacja taka zachodzi. Mamy:\n");
			printf("\nCharakterystyka czastki (LAB): C (GeV)\n");
			printf("   Masa spoczynkowa:     %15.9e\n", pc.m());
			printf("   Ped wzdluz osi OX:    %15.9e\n", pc.px());
			printf("   Ped wzdluz osi OY:    %15.9e\n", pc.py());
			printf("   Ped wzdluz osi OZ:    %15.9e\n", pc.pz());
			printf("   Ped calkowity:        %15.9e\n", sqrt(pc.pp()));
			printf("   Energia calkowita:    %15.9e\n", pc.E());
			printf("\n");	
		}
	}
	else if(N >= 2)
	{
		double theta = MaxKat(pa, pb, m, N);
		tekst_kolor(TEKST_CZERWONY); printf("Maksymalny kat "); tekst_domyslny();
		printf("rozproszenia czastek wynosii ");
		tekst_kolor(TEKST_CZERWONY); printf("%5.3f (stopni)\n", theta/PI*180);
		tekst_domyslny();

		// o prawdopodobienstwie ze czastka polecie w danym kacie
		if(N == 2)
		{
			printf("Biarac jednak pod uwage tylko ");
			tekst_kolor(TEKST_CZERWONY); printf("%3.2f czesci ", alpha); tekst_domyslny();
			printf("liczby czastek: ");
			tekst_kolor(TEKST_CZERWONY); printf("%f\n", PrawKat(pa, pb, m, N, alpha, Niter));
			tekst_domyslny();

			// rysowanie histogramu
			if(histogram)
			{
				PrawKat(pa, pb, m, N, 0, Niter, histogram);
			}
		}	
	}

	printf("---------------------------------------------------------\n");

	// dopisac o maksymalnej masie czastek, o minimalnej energii dla danego zestawu

	printf("\n");	

	delete[] m;
	return 0;
}
//koniec main
